您的位置:首页 > 其它

CodeForces 369 div2 C Coloring Trees DP

2016-08-30 00:47 309 查看
C. Coloring Trees

time limit per test
2 seconds

memory limit per test
256 megabytes

input
standard input

output
standard output

ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and
color the trees in the park. The trees are numbered with integers from 1 to n from
left to right.

Initially, tree i has color ci.
ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m,
where ci = 0 means
that tree i is uncolored.

ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0.
They can color each of them them in any of the m colors from 1 to m.
Coloring the i-th tree with color j requires
exactly pi, j litres
of paint.

The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some
subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors
of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7,
since we can partition the trees into 7 contiguous groups of the same color : {2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.

ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k.
They need your help to determine the minimum amount of paint (in litres) needed to finish the job.

Please note that the friends can't color the trees that are already colored.

Input

The first line contains three integers, n, m and k (1 ≤ k ≤ n ≤ 100, 1 ≤ m ≤ 100) —
the number of trees, number of colors and beauty of the resulting coloring respectively.

The second line contains n integers c1, c2, ..., cn (0 ≤ ci ≤ m),
the initial colors of the trees. ci equals
to 0 if the tree number i is
uncolored, otherwise the i-th tree has color ci.

Then n lines follow. Each of them contains m integers.
The j-th number on the i-th
of them line denotes pi, j (1 ≤ pi, j ≤ 109) —
the amount of litres the friends need to color i-th tree with color j. pi, j's
are specified even for the initially colored trees, but such trees still can't be colored.

Output

Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print  - 1.

Examples

input
3 2 2
0 0 0
1 2
3 4
5 6


output
10


input
3 2 2
2 1 2
1 3
2 4
3 5


output
-1


input
3 2 2
2 0 0
1 3
2 4
3 5


output
5


input
3 2 3
2 1 2
1 3
2 4
3 5


output
0


Note

In the first sample case, coloring the trees with colors 2, 1, 1 minimizes the amount of paint used, which equals to 2 + 3 + 5 = 10.
Note that 1, 1, 1 would not be valid because the beauty of such coloring equals to 1 ({1, 1, 1} is
a way to group the trees into a single group of the same color).

In the second sample case, all the trees are colored, but the beauty of the coloring is 3, so there is no valid coloring, and the answer is  - 1.

In the last sample case, all the trees are colored and the beauty of the coloring matches k, so no paint is used and the answer is 0.

题意:

有n颗树,总共有m种颜色,有些已经上色有些没有,现在要把没有上色的树上色,给某个树上某种颜色有一个价格,然后现在他说连续几个树颜色相同则视为一块,现在要求上色后恰好是k块,花费最少是多少。

题解:

dp[i][j][k]表示把前i颗树上色,并且第i颗上成j色,分成k块的最小代价。

那么如果第i颗已经有颜色C了,那么就dp[i][C][k] = min(dp[i][C][k],dp[i-1][C][k]),

否则,对于任意一个颜色C,dp[i][C][k] = min(dp[i-1][C][k]+cost[i][C],dp[i-1][t][k-1] (t!=C) ).

代码:
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: